<?php

## fieldlist.php
## grabs list of fields

SDV($FieldListPage,'Main/WikiFarm');
SDV($FieldNamePattern,$GroupNamePattern);
SDV($FieldLinkPattern,"($FieldNamePattern):\\/($GroupNamePattern".
  "[\\.\\/]$PageTitlePattern|$GroupNamePattern|)($FragmentPattern)?");
SDV($FieldPageExistsFmt, $WikiPageExistsFmt);
SDV($FieldPageCreateFmt, $WikiPageCreateFmt);

#note: \\b removed from beginning, must be re-added

function WikiFieldList() {
  global $FieldListPage, $FieldNamePattern, $GroupNamePattern,
    $PageTitlePattern, $Fields, $FieldList, $FieldIndex, $FieldPage,
    $FieldName, $DefaultPage, $FieldLinkPattern;
  $page = ReadPage($FieldListPage, '');
# yay for regular expressions!
  $Fields = array( '' );
  $FieldIndex = array( '' => 0 );
  $FieldPage = array( "ThisFarm:/$DefaultPage" );
  $i = 1;
  preg_match_all( "/^[*$]+\s*(\\[\\[|)$FieldLinkPattern(\s+(.*?)|$)/m",
  #"/^[*#]+\s*(\\[\\[|)($FieldNamePattern):\\/($GroupNamePattern".
  #"[\\.\\/]$PageTitlePattern|)(\s+(.*?)|$)/m",
   $page['text'], $field_match, PREG_SET_ORDER);
  foreach ($field_match as $field) {
    $Fields[] = $field[2];
    $FieldIndex[$field[2]] = $i++;
    $FieldPage[] = $field[2].':/'.$field[3];
  }
  $FieldName = $Fields;
  $FieldName[0] = "Farm";
  if (preg_match("/[\\.\\/]($PageTitlePattern)\$/", $DefaultPage, $match))
    $FieldName[0] = $match[1];
}

WikiFieldList();

function FieldExists($field) {
  global $FieldIndex;
  return isset($FieldIndex[$field]);
}

$LinkPatterns[399]["\\b$FieldLinkPattern"] = 'FmtFieldLink';
$OrigScriptUrl = $ScriptUrl;

unset($GetFieldUrl);

function FieldPageUrl($field, $page) {
  global $GetFieldUrl;
  return AddTrailingSlash($GetFieldUrl($field)).$page;
}

function AddTrailingSlash($path) {
  if (substr($path,-1) != '/')
    $path .= '/';
  return $path;
}

function FieldPageExists($field, $pagename) {
  global $PageFileFmt;
  $pagefile = FmtPageName($PageFileFmt,$pagename);
  if (!$pagefile) return false;
  $WikiLibDirs = array (GetFieldWikiLibDir($field), GetFieldWikiDir($field));
#			$field == '' ? 'wiki.d' : "wikifarm/$field.wiki.d");
  foreach ($WikiLibDirs as $dir) {
    if (file_exists("$dir/$pagefile")) return true;
  }
  return false;
}

function FmtFieldLink($dummy0, $link, $text) {
  global $FieldLinkPattern, $FieldNamePattern, $UrlPathPattern, $FieldExists,
    $AsSpacedFunction, $GroupNamePattern, $PageTitlePattern, $FragmentPattern,
    $FieldPageExistsFmt, $FieldPageCreateFmt;
  preg_match("/$FieldLinkPattern/", $link, $match);
  preg_match("/($FragmentPattern)?\$/", $match[0], $anchormatch);
  $field = $match[1];
  if ($field == 'ThisFarm')
    $field='';
  $anchor = $anchormatch[0];
  if ($text == '') {
    $text = $AsSpacedFunction($match[1]).":/";
    if (preg_match("/($GroupNamePattern)[\\.\\/]($PageTitlePattern)/", $match[2],
      $match2)) {
      $text .= $match2[1]."/".$AsSpacedFunction($match2[2]).htmlentities($anchor);
    } else {
      $text .= htmlentities($match[2]);
    }
  }
  if ($field != '' && !FieldExists($field))
    return $text;
  $url = htmlentities(FieldPageUrl($field, $match[2]));
  $exists = 1;

  if (preg_match("/($GroupNamePattern)[\\.\\/]($PageTitlePattern)/", $match[2], $match2)) {
   $url = htmlentities(FieldPageUrl($field, $match2[1] . "/" . $match2[2]));
   if (!FieldPageExists($field, $match[2])) {
     $exists = 0;
   }
  }
  $fmt = $exists ? $FieldPageExistsFmt : $FieldPageCreateFmt;
  $fmt = str_replace('$PageUrl', $url, $fmt);
  $fmt = str_replace('$Fragment', $anchor, $fmt);
  $fmt = str_replace('$LinkText', $text, $fmt);
  return $fmt;
#  if ($exists) {
#    return "<a class='wikiword' href=\"$url\">$text</a>";
#  } else {
#    return "($text)<a class='nonexistent' href=\"$url\"><sup>?</sup></a>";
#  }
}

?>
